<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/22/2005 *
 * ===============                              Last change: 11/22/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : beg_mails.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Sends out reminder mails                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Versendet Erinnerungsmails                       *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!EXT_IS_ACTIVE("beg")) {
	return;
}

// Do not execute when script is in CSS mode
global $CSS;
if (($CSS == 1) || (!defined('__DAILY_RESET'))) return;

// Create timemark from saved month
$mark = mktime(0, 0, 0, $_CONFIG['last_month'], date("d", time()), date('Y', time()));
$SQL = ""; $MODE = "";

// Shall I sent activation or deactivation mail?
$SQL = "SELECT userid, email FROM "._MYSQL_PREFIX."_user_data WHERE (beg_ral_notify ";
switch ($_CONFIG['beg_rallye'])
{
case 'Y': // Begging rallye is activated
	if ($_CONFIG['beg_ral_en_notify'] == "Y")
	{
		// Okay, let's check for member accounts
		$SQL .= "= 0 OR (beg_ral_notify > 0 AND beg_ral_en_notify < beg_ral_di_notify)";
		$MODE = "en";
	}
	 else
	{
		// Do not notify!
		$SQL = "";
	}
	break;

case 'N': // Begging rallye is deactivated
	if ($_CONFIG['beg_ral_di_notify'] == "Y")
	{
		// Okay, let's check for member accounts
		$SQL .= " > 0 AND beg_ral_di_notify < beg_ral_en_notify";
		$MODE = "di";
	}
	 else
	{
		// Do not notify!
		$SQL = "";
	}
	break;
}

if (!empty($SQL))
{
	// The SQL command needs to be finisched here (only confirmed accounts!)
	$SQL .= ") AND status='CONFIRMED' ORDER BY last_online ASC";

	// Prepare data for the template
	define('__BEG_MIN_POINTS' , TRANSLATE_COMMA($_CONFIG['beg_points']));
	define('__BEG_MAX_POINTS' , TRANSLATE_COMMA($_CONFIG['beg_points_max']));
	define('__BEG_MAX_WINNERS', round($_CONFIG['beg_ranks']));
	if ($_CONFIG['beg_ip_timeout'] == 0)
	{
		// No IP locking setuped!
		define('__BEG_IP_LOCKER', BEG_NO_LIMITATION);
	}
	 else
	{
		// Create timemark
		define('__BEG_IP_LOCKER', CREATE_FANCY_TIME($_CONFIG['beg_ip_timeout']));
	}

	// Check for accounts to be notified
	$result_main = SQL_QUERY($SQL, __FILE__, __LINE__);
	if (SQL_NUMROWS($result_main) > 0)
	{
		// Normal notification mails or bonus mails?
		$MAIL_MODE = (($_CONFIG['beg_notify_bonus'] > 0) && ($MODE == "en") && (EXT_IS_ACTIVE("bonus")));

		// Generate subject line
		$eval = "\$SUBJECT = BEG_RALLYE_".strtoupper($MODE)."_NOTIFY;";
		eval($eval);

		// Load message body for bonus mails
		$MSG = LOAD_EMAIL_TEMPLATE("beg_en_notify_body", "", "{PER}uid{PER}");
		$RECEIVER = ""; $UIDs = array();

		// Okay lets notify all users!
		while(list($uid, $email) = SQL_FETCHROW($result_main))
		{
			// Update account
			$result_update = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_data
SET beg_ral_notify='%s', beg_ral_%s_notify='%s' WHERE userid=%s LIMIT 1",
 array(time(), $MODE, time(), $uid), __FILE__, __LINE__);

			// Load email template and send it to the user!
			if ($MAIL_MODE)
			{
				// Add userid to queue
				$UIDs[] = $uid;
			}
			 else
			{
				// Send normal notification mail to the members
				$MSG = LOAD_EMAIL_TEMPLATE("beg_".$MODE."_notify", array(), $uid);
				SEND_EMAIL($email, $SUBJECT, $MSG);
			}
		}

		// Shall I send out bonus mails?
		if ($MAIL_MODE)
		{
			// Okay, make array to string
			$RECEIVER = implode(";", $UIDs);
			$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_bonus
(subject, text, receivers, points, time, data_type, timestamp, url, cat_id, target_send, mails_sent, is_notify)
VALUES ('%s','%s','%s','%s','%s','NEW', UNIX_TIMESTAMP(), '%s','%s','%s','%s','Y')",
 array(
	$SUBJECT,
	$MSG,
	$RECEIVER,
	$_CONFIG['beg_notify_bonus'],
	$_CONFIG['beg_notify_wait'],
	URL."/modules.php?module=index&what=login",
	0,
	SELECTION_COUNT(explode(";", $RECEIVER)),
	SQL_NUMROWS($result_main),
), __FILE__, __LINE__);
		}
	}

	// Free memory
	SQL_FREERESULT($result_main);
}

//
?>
